Index: branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/trcsub.F90
===================================================================
--- branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 4616)
+++ branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 4617)
@@ -25,10 +25,7 @@
    USE zdf_oce
    USE domvvl
-   USE divcur          ! hor. divergence and curl      (div & cur routines)
+   USE divhor          ! hor. divergence
    USE sbcrnf, ONLY: h_rnf, nk_rnf   ! River runoff 
    USE bdy_oce
-#if defined key_obc
-   USE obc_oce, ONLY: obctmsk
-#endif
 #if defined key_agrif
    USE agrif_opa_update
@@ -43,5 +40,4 @@
    PUBLIC   trc_sub_ssh      ! called by trc_stp to reset physics variables
 
-   !!* Module variables
    REAL(wp)  :: r1_ndttrc     !    1 /  nn_dttrc 
    REAL(wp)  :: r1_ndttrcp1   !    1 / (nn_dttrc+1) 
@@ -50,5 +46,5 @@
 #  include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! NEMO/TOP 3.7 , NEMO Consortium (2014)
    !! $Id: trcstp.F90 2528 2010-12-27 17:33:53Z rblod $ 
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
@@ -94,13 +90,13 @@
           tsn_tm  (:,:,:,jp_sal) = tsn_tm  (:,:,:,jp_sal) + tsn  (:,:,:,jp_sal) * fse3t(:,:,:)  
           rhop_tm (:,:,:)        = rhop_tm (:,:,:)        + rhop (:,:,:)        * fse3t(:,:,:)  
-          avt_tm  (:,:,:)        = avt_tm  (:,:,:)        + avt  (:,:,:)        * fse3w(:,:,:)  
+          avt_tm  (:,:,:)        = avt_tm  (:,:,:)        + avt  (:,:,:) 
 # if defined key_zdfddm
-          avs_tm  (:,:,:)        = avs_tm  (:,:,:)        + avs  (:,:,:)        * fse3w(:,:,:)  
+          avs_tm  (:,:,:)        = avs_tm  (:,:,:)        + avs  (:,:,:) 
 # endif
 #if defined key_ldfslp
-          wslpi_tm(:,:,:)        = wslpi_tm(:,:,:)        + wslpi(:,:,:)        * fse3w(:,:,:) 
-          wslpj_tm(:,:,:)        = wslpj_tm(:,:,:)        + wslpj(:,:,:)        * fse3w(:,:,:) 
-          uslp_tm (:,:,:)        = uslp_tm (:,:,:)        + uslp (:,:,:)        * fse3u(:,:,:) 
-          vslp_tm (:,:,:)        = vslp_tm (:,:,:)        + vslp (:,:,:)        * fse3v(:,:,:) 
+          wslpi_tm(:,:,:)        = wslpi_tm(:,:,:)        + wslpi(:,:,:) 
+          wslpj_tm(:,:,:)        = wslpj_tm(:,:,:)        + wslpj(:,:,:)
+          uslp_tm (:,:,:)        = uslp_tm (:,:,:)        + uslp (:,:,:) 
+          vslp_tm (:,:,:)        = vslp_tm (:,:,:)        + vslp (:,:,:)
 #endif
 # if defined key_trabbl
@@ -127,44 +123,10 @@
           wndm_tm  (:,:)         = wndm_tm  (:,:)         + wndm  (:,:)
           !
-#if defined key_traldf_c3d
-          ahtt_tm  (:,:,:)       = ahtt_tm  (:,:,:)       + ahtt(:,:,:)         * fse3t(:,:,:)
-          ahtu_tm  (:,:,:)       = ahtu_tm  (:,:,:)       + ahtu(:,:,:)         * fse3u(:,:,:)
-          ahtv_tm  (:,:,:)       = ahtv_tm  (:,:,:)       + ahtv(:,:,:)         * fse3v(:,:,:)
-          ahtw_tm  (:,:,:)       = ahtw_tm  (:,:,:)       + ahtw(:,:,:)         * fse3w(:,:,:)
-#elif defined key_traldf_c2d
-          ahtt_tm  (:,:)         = ahtt_tm  (:,:)         + ahtt(:,:)
-          ahtu_tm  (:,:)         = ahtu_tm  (:,:)         + ahtu(:,:)
-          ahtv_tm  (:,:)         = ahtv_tm  (:,:)         + ahtv(:,:)
-          ahtw_tm  (:,:)         = ahtw_tm  (:,:)         + ahtw(:,:)
-#elif defined key_traldf_c1d
-          ahtt_tm  (:)           = ahtt_tm  (:,:)         + ahtt(:)
-          ahtu_tm  (:)           = ahtu_tm  (:,:)         + ahtu(:)
-          ahtv_tm  (:)           = ahtv_tm  (:,:)         + ahtv(:)
-          ahtw_tm  (:)           = ahtw_tm  (:,:)         + ahtw(:)
-#else
-          ahtt_tm                = ahtt_tm                + ahtt
-          ahtu_tm                = ahtu_tm                + ahtu
-          ahtv_tm                = ahtv_tm                + ahtv
-          ahtw_tm                = ahtw_tm                + ahtw
-#endif
-#if defined key_traldf_eiv
-#  if defined key_traldf_c3d
-          aeiu_tm  (:,:,:)       = aeiu_tm  (:,:,:)       + aeiu(:,:,:)         * fse3u(:,:,:)
-          aeiv_tm  (:,:,:)       = aeiv_tm  (:,:,:)       + aeiv(:,:,:)         * fse3v(:,:,:)
-          aeiw_tm  (:,:,:)       = aeiw_tm  (:,:,:)       + aeiw(:,:,:)         * fse3w(:,:,:)
-#  elif defined key_traldf_c2d
-          aeiu_tm  (:,:)         = aeiu_tm  (:,:)         + aeiu(:,:)
-          aeiv_tm  (:,:)         = aeiv_tm  (:,:)         + aeiv(:,:)
-          aeiw_tm  (:,:)         = aeiw_tm  (:,:)         + aeiw(:,:)
-#  elif defined key_traldf_c1d
-          aeiu_tm  (:)           = aeiu_tm  (:,:)         + aeiu(:)
-          aeiv_tm  (:)           = aeiv_tm  (:,:)         + aeiv(:)
-          aeiw_tm  (:)           = aeiw_tm  (:,:)         + aeiw(:)
-#  else
-          aeiu_tm                = aeiu_tm                + aeiu
-          aeiv_tm                = aeiv_tm                + aeiv
-          aeiw_tm                = aeiw_tm                + aeiw
-#  endif
-#endif
+          ahtu_tm  (:,:,:)       = ahtu_tm  (:,:,:)       + ahtu(:,:,:)
+          ahtv_tm  (:,:,:)       = ahtv_tm  (:,:,:)       + ahtv(:,:,:)
+          IF( ln_ldfeiv ) THEN
+            aeiu_tm  (:,:,:)     = aeiu_tm  (:,:,:)       + aeiu(:,:,:)
+            aeiv_tm  (:,:,:)     = aeiv_tm  (:,:,:)       + aeiv(:,:,:)
+          ENDIF
 
       ELSE                           !  It is time to substep 
@@ -179,10 +141,10 @@
          avs_temp   (:,:,:)      = avs   (:,:,:)
 # endif
-#if defined key_ldfslp
-         wslpi_temp (:,:,:)      = wslpi (:,:,:)
-         wslpj_temp (:,:,:)      = wslpj (:,:,:)
-         uslp_temp  (:,:,:)      = uslp  (:,:,:)
-         vslp_temp  (:,:,:)      = vslp  (:,:,:)
-#endif
+         IF( l_ldfslp ) THEN
+            uslp_temp  (:,:,:)      = uslp  (:,:,:)
+            vslp_temp  (:,:,:)      = vslp  (:,:,:)
+            wslpi_temp (:,:,:)      = wslpi (:,:,:)
+            wslpj_temp (:,:,:)      = wslpj (:,:,:)
+         ENDIF
 # if defined key_trabbl
           IF( nn_bbl_ldf == 1 ) THEN
@@ -214,50 +176,13 @@
          qsr_temp   (:,:)        = qsr   (:,:)
          wndm_temp  (:,:)        = wndm  (:,:)
-#if defined key_traldf_c3d
+         !
          ahtu_temp  (:,:,:)      = ahtu  (:,:,:)
          ahtv_temp  (:,:,:)      = ahtv  (:,:,:)
-         ahtw_temp  (:,:,:)      = ahtw  (:,:,:)
-         ahtt_temp  (:,:,:)      = ahtt  (:,:,:)
-#elif defined key_traldf_c2d
-         ahtu_temp  (:,:)        = ahtu  (:,:)
-         ahtv_temp  (:,:)        = ahtv  (:,:)
-         ahtw_temp  (:,:)        = ahtw  (:,:)
-         ahtt_temp  (:,:)        = ahtt  (:,:)
-#elif defined key_traldf_c1d
-         ahtu_temp  (:)          = ahtu  (:)
-         ahtv_temp  (:)          = ahtv  (:)
-         ahtw_temp  (:)          = ahtw  (:)
-         ahtt_temp  (:)          = ahtt  (:)
-#else
-         ahtu_temp               = ahtu
-         ahtv_temp               = ahtv
-         ahtw_temp               = ahtw
-         ahtt_temp               = ahtt
-#endif
-
-#if defined key_traldf_eiv
-# if defined key_traldf_c3d
-         aeiu_temp  (:,:,:)      = aeiu(:,:,:)
-         aeiv_temp  (:,:,:)      = aeiv(:,:,:)
-         aeiw_temp  (:,:,:)      = aeiw(:,:,:)
-# elif defined key_traldf_c2d
-         aeiu_temp  (:,:)        = aeiu(:,:)
-         aeiv_temp  (:,:)        = aeiv(:,:)
-         aeiw_temp  (:,:)        = aeiw(:,:)
-# elif defined key_traldf_c1d
-         aeiu_temp  (:)          = aeiu(:)
-         aeiv_temp  (:)          = aeiv(:)
-         aeiw_temp  (:)          = aeiw(:)
-# else
-         aeiu_temp               = aeiu
-         aeiv_temp               = aeiv
-         aeiw_temp               = aeiw
-# endif
-#endif
+         IF( ln_ldfeiv ) THEN
+            aeiu_temp  (:,:,:)   = aeiu(:,:,:)
+            aeiv_temp  (:,:,:)   = aeiv(:,:,:)
+         ENDIF
          !                                    !  Variables reset in trc_sub_ssh
-         rotn_temp  (:,:,:)      = rotn  (:,:,:)
          hdivn_temp (:,:,:)      = hdivn (:,:,:)
-         rotb_temp  (:,:,:)      = rotb  (:,:,:)
-         hdivb_temp (:,:,:)      = hdivb (:,:,:)
          hu_temp    (:,:)        = hu    (:,:)
          hv_temp    (:,:)        = hv    (:,:)
@@ -287,14 +212,14 @@
          tsn_tm   (:,:,:,jp_sal) = tsn_tm  (:,:,:,jp_sal) + tsn  (:,:,:,jp_sal) * e3t_temp(:,:,:)  
          rhop_tm (:,:,:)         = rhop_tm (:,:,:)        + rhop (:,:,:)        * e3t_temp(:,:,:)  
-         avt_tm   (:,:,:)        = avt_tm  (:,:,:)        + avt  (:,:,:)        * e3w_temp(:,:,:)  
+         avt_tm   (:,:,:)        = avt_tm  (:,:,:)        + avt  (:,:,:)  
 # if defined key_zdfddm
-         avs_tm   (:,:,:)        = avs_tm  (:,:,:)        + avs  (:,:,:)        * e3w_temp(:,:,:)  
-# endif
-#if defined key_ldfslp
-         wslpi_tm (:,:,:)        = wslpi_tm(:,:,:)        + wslpi(:,:,:)        * e3w_temp(:,:,:) 
-         wslpj_tm (:,:,:)        = wslpj_tm(:,:,:)        + wslpj(:,:,:)        * e3w_temp(:,:,:) 
-         uslp_tm  (:,:,:)        = uslp_tm (:,:,:)        + uslp (:,:,:)        * e3u_temp(:,:,:) 
-         vslp_tm  (:,:,:)        = vslp_tm (:,:,:)        + vslp (:,:,:)        * e3v_temp(:,:,:) 
-#endif
+         avs_tm   (:,:,:)        = avs_tm  (:,:,:)        + avs  (:,:,:)  
+# endif
+         IF( l_ldfslp ) THEN
+            wslpi_tm (:,:,:)        = wslpi_tm(:,:,:)        + wslpi(:,:,:)
+            wslpj_tm (:,:,:)        = wslpj_tm(:,:,:)        + wslpj(:,:,:)
+            uslp_tm  (:,:,:)        = uslp_tm (:,:,:)        + uslp (:,:,:)
+            vslp_tm  (:,:,:)        = vslp_tm (:,:,:)        + vslp (:,:,:) 
+         ENDIF
 # if defined key_trabbl
           IF( nn_bbl_ldf == 1 ) THEN
@@ -377,96 +302,32 @@
                   tsn  (ji,jj,jk,jp_sal) = tsn_tm  (ji,jj,jk,jp_sal) * z1_ne3t
                   rhop (ji,jj,jk)        = rhop_tm (ji,jj,jk)        * z1_ne3t
-                  avt  (ji,jj,jk)        = avt_tm  (ji,jj,jk)        * z1_ne3w
+                  avt  (ji,jj,jk)        = avt_tm  (ji,jj,jk)        * r1_ndttrcp1
 # if defined key_zdfddm
-                  avs  (ji,jj,jk)        = avs_tm  (ji,jj,jk)        * z1_ne3w
-# endif
-#if defined key_ldfslp
-                  wslpi(ji,jj,jk)        = wslpi_tm(ji,jj,jk)        * z1_ne3w 
-                  wslpj(ji,jj,jk)        = wslpj_tm(ji,jj,jk)        * z1_ne3w 
-                  uslp (ji,jj,jk)        = uslp_tm (ji,jj,jk)        * z1_ne3u 
-                  vslp (ji,jj,jk)        = vslp_tm (ji,jj,jk)        * z1_ne3v 
-#endif
-               ENDDO
-            ENDDO
-         ENDDO
-
-#if defined key_traldf_c3d
-          ahtt_tm  (:,:,:)       = ahtt_tm  (:,:,:)       + ahtt(:,:,:)         * e3t_temp(:,:,:)
-          ahtu_tm  (:,:,:)       = ahtu_tm  (:,:,:)       + ahtu(:,:,:)         * e3u_temp(:,:,:)
-          ahtv_tm  (:,:,:)       = ahtv_tm  (:,:,:)       + ahtv(:,:,:)         * e3v_temp(:,:,:)
-          ahtw_tm  (:,:,:)       = ahtw_tm  (:,:,:)       + ahtw(:,:,:)         * e3w_temp(:,:,:)
-          !
-          ahtt     (:,:,:)       = ahtt_tm  (:,:,:) * r1_ndttrcp1  / fse3t(:,:,:)
-          ahtu     (:,:,:)       = ahtu_tm  (:,:,:) * r1_ndttrcp1  / fse3u(:,:,:)
-          ahtv     (:,:,:)       = ahtv_tm  (:,:,:) * r1_ndttrcp1  / fse3v(:,:,:)
-          ahtw     (:,:,:)       = ahtw_tm  (:,:,:) * r1_ndttrcp1  / fse3w(:,:,:)
-#elif defined key_traldf_c2d
-          ahtt_tm  (:,:)         = ahtt_tm  (:,:)         + ahtt(:,:)
-          ahtu_tm  (:,:)         = ahtu_tm  (:,:)         + ahtu(:,:)
-          ahtv_tm  (:,:)         = ahtv_tm  (:,:)         + ahtv(:,:)
-          ahtw_tm  (:,:)         = ahtw_tm  (:,:)         + ahtw(:,:)
-          !
-          ahtt     (:,:)         = ahtt_tm  (:,:)   * r1_ndttrcp1
-          ahtu     (:,:)         = ahtu_tm  (:,:)   * r1_ndttrcp1
-          ahtv     (:,:)         = ahtv_tm  (:,:)   * r1_ndttrcp1
-          ahtw     (:,:)         = ahtw_tm  (:,:)   * r1_ndttrcp1
-#elif defined key_traldf_c1d
-          ahtt_tm  (:)           = ahtt_tm  (:,:)         + ahtt(:)
-          ahtu_tm  (:)           = ahtu_tm  (:,:)         + ahtu(:)
-          ahtv_tm  (:)           = ahtv_tm  (:,:)         + ahtv(:)
-          ahtw_tm  (:)           = ahtw_tm  (:,:)         + ahtw(:)
-          !
-          ahtt     (:)           = ahtt_tm  (:)     * r1_ndttrcp1
-          ahtu     (:)           = ahtu_tm  (:)     * r1_ndttrcp1
-          ahtv     (:)           = ahtv_tm  (:)     * r1_ndttrcp1
-          ahtw     (:)           = ahtw_tm  (:)     * r1_ndttrcp1
-#else
-          ahtt_tm                = ahtt_tm                + ahtt
-          ahtu_tm                = ahtu_tm                + ahtu
-          ahtv_tm                = ahtv_tm                + ahtv
-          ahtw_tm                = ahtw_tm                + ahtw
-          !
-          ahtt                   = ahtt_tm          * r1_ndttrcp1
-          ahtu                   = ahtu_tm          * r1_ndttrcp1
-          ahtv                   = ahtv_tm          * r1_ndttrcp1
-          ahtw                   = ahtw_tm          * r1_ndttrcp1
-#endif
-
-#if defined key_traldf_eiv
-# if defined key_traldf_c3d
-          aeiu_tm  (:,:,:)       = aeiu_tm  (:,:,:)       + aeiu(:,:,:)         * e3u_temp(:,:,:)
-          aeiv_tm  (:,:,:)       = aeiv_tm  (:,:,:)       + aeiv(:,:,:)         * e3v_temp(:,:,:)
-          aeiw_tm  (:,:,:)       = aeiw_tm  (:,:,:)       + aeiw(:,:,:)         * e3w_temp(:,:,:)
-          !
-          aeiu     (:,:,:)       = aeiu_tm  (:,:,:) * r1_ndttrcp1  / fse3u(:,:,:)
-          aeiv     (:,:,:)       = aeiv_tm  (:,:,:) * r1_ndttrcp1  / fse3v(:,:,:)
-          aeiw     (:,:,:)       = aeiw_tm  (:,:,:) * r1_ndttrcp1  / fse3w(:,:,:)
-# elif defined key_traldf_c2d
-          aeiu_tm  (:,:)         = aeiu_tm  (:,:)         + aeiu(:,:)
-          aeiv_tm  (:,:)         = aeiv_tm  (:,:)         + aeiv(:,:)
-          aeiw_tm  (:,:)         = aeiw_tm  (:,:)         + aeiw(:,:)
-          !
-          aeiu     (:,:)         = aeiu_tm  (:,:)   * r1_ndttrcp1
-          aeiv     (:,:)         = aeiv_tm  (:,:)   * r1_ndttrcp1
-          aeiw     (:,:)         = aeiw_tm  (:,:)   * r1_ndttrcp1
-# elif defined key_traldf_c1d
-          aeiu_tm  (:)           = aeiu_tm  (:,:)         + aeiu(:)
-          aeiv_tm  (:)           = aeiv_tm  (:,:)         + aeiv(:)
-          aeiw_tm  (:)           = aeiw_tm  (:,:)         + aeiw(:)
-          !
-          aeiu     (:)           = aeiu_tm  (:)     * r1_ndttrcp1
-          aeiv     (:)           = aeiv_tm  (:)     * r1_ndttrcp1
-          aeiw     (:)           = aeiw_tm  (:)     * r1_ndttrcp1
-# else
-          aeiu_tm                = aeiu_tm                + aeiu
-          aeiv_tm                = aeiv_tm                + aeiv
-          aeiw_tm                = aeiw_tm                + aeiw
-          !
-          aeiu                   = aeiu_tm          * r1_ndttrcp1
-          aeiv                   = aeiv_tm          * r1_ndttrcp1
-          aeiw                   = aeiw_tm          * r1_ndttrcp1
-# endif
-#endif
-
+                  avs  (ji,jj,jk)        = avs_tm  (ji,jj,jk)        * r1_ndttrcp1
+# endif
+               END DO
+            END DO
+         END DO
+         IF( l_ldfslp ) THEN
+            wslpi(:,:,:)        = wslpi_tm(:,:,:)        * r1_ndttrcp1 
+            wslpj(:,:,:)        = wslpj_tm(:,:,:)        * r1_ndttrcp1 
+            uslp (:,:,:)        = uslp_tm (:,:,:)        * r1_ndttrcp1 
+            vslp (:,:,:)        = vslp_tm (:,:,:)        * r1_ndttrcp1 
+         ENDIF
+         !
+         ahtu_tm(:,:,:) = ahtu_tm(:,:,:) + ahtu(:,:,:)
+         ahtv_tm(:,:,:) = ahtv_tm(:,:,:) + ahtv(:,:,:)
+         !
+         ahtu   (:,:,:) = ahtu_tm(:,:,:) * r1_ndttrcp1
+         ahtv   (:,:,:) = ahtv_tm(:,:,:) * r1_ndttrcp1
+         IF( ln_ldfeiv ) THEN
+            aeiu_tm(:,:,:) = aeiu_tm(:,:,:) + aeiu(:,:,:)
+            aeiv_tm(:,:,:) = aeiv_tm(:,:,:) + aeiv(:,:,:)
+            !
+            aeiu   (:,:,:) = aeiu_tm(:,:,:) * r1_ndttrcp1
+            aeiv   (:,:,:) = aeiv_tm(:,:,:) * r1_ndttrcp1
+         ENDIF
+
+!!gm  All those lbc_lnk are useless since the averaging is done over full arrays !
          CALL lbc_lnk( un    (:,:,:)       , 'U',-1. ) 
          CALL lbc_lnk( vn    (:,:,:)       , 'V',-1. ) 
@@ -478,10 +339,10 @@
           CALL lbc_lnk( avs  (:,:,:)       , 'W', 1. ) 
 # endif
-#if defined key_ldfslp
-         CALL lbc_lnk( uslp  (:,:,:)       , 'U',-1. ) 
-         CALL lbc_lnk( vslp  (:,:,:)       , 'V',-1. ) 
-         CALL lbc_lnk( wslpi (:,:,:)       , 'W',-1. ) 
-         CALL lbc_lnk( wslpj (:,:,:)       , 'W',-1. ) 
-#endif
+         IF( l_ldfslp ) THEN
+            CALL lbc_lnk( uslp  (:,:,:)       , 'U',-1. ) 
+            CALL lbc_lnk( vslp  (:,:,:)       , 'V',-1. ) 
+            CALL lbc_lnk( wslpi (:,:,:)       , 'W',-1. ) 
+            CALL lbc_lnk( wslpj (:,:,:)       , 'W',-1. ) 
+         ENDIF
          CALL lbc_lnk( sshn  (:,:)         , 'T', 1. ) 
 !!Z~     CALL lbc_lnk( sshu_n(:,:)         , 'U', 1. ) 
@@ -513,34 +374,15 @@
          ENDIF
 # endif
-#if defined key_traldf_c3d
-         CALL lbc_lnk( ahtt  (:,:,:)       , 'T', 1. ) 
          CALL lbc_lnk( ahtu  (:,:,:)       , 'U', 1. ) 
          CALL lbc_lnk( ahtv  (:,:,:)       , 'V', 1. ) 
-         CALL lbc_lnk( ahtw  (:,:,:)       , 'W', 1. ) 
-#elif defined key_traldf_c2d
-         CALL lbc_lnk( ahtt  (:,:)         , 'T', 1. ) 
-         CALL lbc_lnk( ahtu  (:,:)         , 'U', 1. ) 
-         CALL lbc_lnk( ahtv  (:,:)         , 'V', 1. ) 
-         CALL lbc_lnk( ahtw  (:,:)         , 'W', 1. ) 
-#endif
-#if defined key_traldf_eiv
-#if defined key_traldf_c3d
-         CALL lbc_lnk( aeiu  (:,:,:)       , 'U', 1. ) 
-         CALL lbc_lnk( aeiv  (:,:,:)       , 'V', 1. ) 
-         CALL lbc_lnk( aeiw  (:,:,:)       , 'W', 1. ) 
-#elif defined key_traldf_c2d
-         CALL lbc_lnk( aeiu  (:,:)         , 'U', 1. ) 
-         CALL lbc_lnk( aeiv  (:,:)         , 'V', 1. ) 
-         CALL lbc_lnk( aeiw  (:,:)         , 'W', 1. ) 
-#endif
-#endif
+         IF( ln_ldfeiv ) THEN
+            CALL lbc_lnk( aeiu  (:,:,:)    , 'U', 1. ) 
+            CALL lbc_lnk( aeiv  (:,:,:)    , 'V', 1. ) 
+         ENDIF
          !
          CALL trc_sub_ssh( kt )         ! after ssh & vertical velocity
          !
          CALL lbc_lnk( wn    (:,:,:)       , 'W',-1. ) 
-         CALL lbc_lnk( rotn  (:,:,:)       , 'F', 1. ) 
          CALL lbc_lnk( hdivn (:,:,:)       , 'T', 1. ) 
-         CALL lbc_lnk( rotb  (:,:,:)       , 'F', 1. ) 
-         CALL lbc_lnk( hdivb (:,:,:)       , 'T', 1. ) 
          CALL lbc_lnk( hu    (:,:)         , 'U', 1. ) 
          CALL lbc_lnk( hv    (:,:)         , 'V', 1. ) 
@@ -553,12 +395,12 @@
    END SUBROUTINE trc_sub_stp
 
+
    SUBROUTINE trc_sub_ini
       !!-------------------------------------------------------------------
       !!                     ***  ROUTINE trc_sub_ini  ***
       !!                      
-      !! ** Purpose : Initialize variables needed for sub-stepping passive tracers
+      !! ** Purpose :   Initialize variables needed for sub-stepping passive tracers
       !! 
-      !! ** Method  : 
-      !!              Compute the averages for sub-stepping
+      !! ** Method  :   Compute the averages for sub-stepping
       !!-------------------------------------------------------------------
       INTEGER ::   ierr
@@ -580,14 +422,14 @@
       tsn_tm  (:,:,:,jp_sal) = tsn  (:,:,:,jp_sal) * fse3t(:,:,:)  
       rhop_tm (:,:,:)        = rhop (:,:,:)        * fse3t(:,:,:)  
-      avt_tm  (:,:,:)        = avt  (:,:,:)        * fse3w(:,:,:)  
+      avt_tm  (:,:,:)        = avt  (:,:,:) 
 # if defined key_zdfddm
-      avs_tm  (:,:,:)        = avs  (:,:,:)        * fse3w(:,:,:)  
-# endif
-#if defined key_ldfslp
-      wslpi_tm(:,:,:)        = wslpi(:,:,:)        * fse3w(:,:,:) 
-      wslpj_tm(:,:,:)        = wslpj(:,:,:)        * fse3w(:,:,:) 
-      uslp_tm (:,:,:)        = uslp (:,:,:)        * fse3u(:,:,:) 
-      vslp_tm (:,:,:)        = vslp (:,:,:)        * fse3v(:,:,:) 
-#endif
+      avs_tm  (:,:,:)        = avs  (:,:,:)  
+# endif
+      IF( l_ldfslp ) THEN
+         wslpi_tm(:,:,:)        = wslpi(:,:,:)
+         wslpj_tm(:,:,:)        = wslpj(:,:,:)
+         uslp_tm (:,:,:)        = uslp (:,:,:)
+         vslp_tm (:,:,:)        = vslp (:,:,:)
+      ENDIF
       sshn_tm  (:,:) = sshn  (:,:) 
 !!Z~  sshu_n_tm(:,:) = sshu_n(:,:) 
@@ -614,49 +456,16 @@
 # endif
       !
-#if defined key_traldf_c3d
-      ahtt_tm(:,:,:) = ahtt(:,:,:) * fse3t(:,:,:)
-      ahtu_tm(:,:,:) = ahtu(:,:,:) * fse3u(:,:,:)
-      ahtv_tm(:,:,:) = ahtv(:,:,:) * fse3v(:,:,:)
-      ahtw_tm(:,:,:) = ahtw(:,:,:) * fse3w(:,:,:)
-#elif defined key_traldf_c2d
-      ahtt_tm(:,:)   = ahtt(:,:)
-      ahtu_tm(:,:)   = ahtu(:,:)
-      ahtv_tm(:,:)   = ahtv(:,:)
-      ahtw_tm(:,:)   = ahtw(:,:)
-#elif defined key_traldf_c1d
-      ahtt_tm(:)     = ahtt(:)
-      ahtu_tm(:)     = ahtu(:)
-      ahtv_tm(:)     = ahtv(:)
-      ahtw_tm(:)     = ahtw(:)
-#else
-      ahtt_tm        = ahtt
-      ahtu_tm        = ahtu
-      ahtv_tm        = ahtv
-      ahtw_tm        = ahtw
-#endif
-      !
-#if defined key_traldf_eiv
-#  if defined key_traldf_c3d
-      aeiu_tm(:,:,:) = aeiu(:,:,:) * fse3u(:,:,:)
-      aeiv_tm(:,:,:) = aeiv(:,:,:) * fse3v(:,:,:)
-      aeiw_tm(:,:,:) = aeiw(:,:,:) * fse3w(:,:,:)
-#  elif defined key_traldf_c2d
-      aeiu_tm(:,:)   = aeiu(:,:)
-      aeiv_tm(:,:)   = aeiv(:,:)
-      aeiw_tm(:,:)   = aeiw(:,:)
-#  elif defined key_traldf_c1d
-      aeiu_tm(:)     = aeiu(:)
-      aeiv_tm(:)     = aeiv(:)
-      aeiw_tm(:)     = aeiw(:)
-#  else
-      aeiu_tm        = aeiu
-      aeiv_tm        = aeiv
-      aeiw_tm        = aeiw
-#  endif
-#endif
+      ahtu_tm(:,:,:) = ahtu(:,:,:)
+      ahtv_tm(:,:,:) = ahtv(:,:,:)
+      !
+      IF( ln_ldfeiv ) THEN
+         aeiu_tm(:,:,:) = aeiu(:,:,:)
+         aeiv_tm(:,:,:) = aeiv(:,:,:)
+      ENDIF
       !
       IF( nn_timing == 1 )  CALL timing_stop('trc_sub_ini')
       !
    END SUBROUTINE trc_sub_ini
+
 
    SUBROUTINE trc_sub_reset( kt )
@@ -685,10 +494,10 @@
       avs   (:,:,:)   =  avs_temp   (:,:,:)
 # endif
-#if defined key_ldfslp
-      wslpi (:,:,:)   =  wslpi_temp (:,:,:)
-      wslpj (:,:,:)   =  wslpj_temp (:,:,:)
-      uslp  (:,:,:)   =  uslp_temp  (:,:,:)
-      vslp  (:,:,:)   =  vslp_temp  (:,:,:)
-#endif
+      IF( l_ldfslp ) THEN
+         wslpi (:,:,:)   =  wslpi_temp (:,:,:)
+         wslpj (:,:,:)   =  wslpj_temp (:,:,:)
+         uslp  (:,:,:)   =  uslp_temp  (:,:,:)
+         vslp  (:,:,:)   =  vslp_temp  (:,:,:)
+      ENDIF
       sshn  (:,:)     =  sshn_temp  (:,:)
       sshb  (:,:)     =  sshb_temp  (:,:)
@@ -722,49 +531,12 @@
 # endif
       !
-#if defined key_traldf_c3d
       ahtu  (:,:,:)   =  ahtu_temp  (:,:,:)
       ahtv  (:,:,:)   =  ahtv_temp  (:,:,:)
-      ahtw  (:,:,:)   =  ahtw_temp  (:,:,:)
-      ahtt  (:,:,:)   =  ahtt_temp  (:,:,:)
-#elif defined key_traldf_c2d
-      ahtu  (:,:)     =  ahtu_temp  (:,:)
-      ahtv  (:,:)     =  ahtv_temp  (:,:)
-      ahtw  (:,:)     =  ahtw_temp  (:,:)
-      ahtt  (:,:)     =  ahtt_temp  (:,:)
-#elif defined key_traldf_c1d
-      ahtu  (:)       =  ahtu_temp  (:)
-      ahtv  (:)       =  ahtv_temp  (:)
-      ahtw  (:)       =  ahtw_temp  (:)
-      ahtt  (:)       =  ahtt_temp  (:)
-#else
-      ahtu            =  ahtu_temp
-      ahtv            =  ahtv_temp
-      ahtw            =  ahtw_temp
-      ahtt            =  ahtt_temp
-#endif
-      !
-#if defined key_traldf_eiv
-#if defined key_traldf_c3d
-      aeiu  (:,:,:)  =  aeiu_temp(:,:,:)
-      aeiv  (:,:,:)  =  aeiv_temp(:,:,:)
-      aeiw  (:,:,:)  =  aeiw_temp(:,:,:)
-#elif defined key_traldf_c2d
-      aeiu  (:,:)    =  aeiu_temp(:,:)
-      aeiv  (:,:)    =  aeiv_temp(:,:)
-      aeiw  (:,:)    =  aeiw_temp(:,:)
-#elif defined key_traldf_c1d
-      aeiu  (:)      =  aeiu_temp(:)
-      aeiv  (:)      =  aeiv_temp(:)
-      aeiw  (:)      =  aeiw_temp(:)
-#else
-      aeiu           =  aeiu_temp
-      aeiv           =  aeiv_temp
-      aeiw           =  aeiw_temp
-#endif
-#endif 
+      !
+      IF( ln_ldfeiv ) THEN
+         aeiu  (:,:,:)  =  aeiu_temp(:,:,:)
+         aeiv  (:,:,:)  =  aeiv_temp(:,:,:)
+      ENDIF
       hdivn (:,:,:)   =  hdivn_temp (:,:,:)
-      rotn  (:,:,:)   =  rotn_temp  (:,:,:)
-      hdivb (:,:,:)   =  hdivb_temp (:,:,:)
-      rotb  (:,:,:)   =  rotb_temp  (:,:,:)
       hu    (:,:)     =  hu_temp    (:,:)
       hv    (:,:)     =  hv_temp    (:,:)
@@ -773,12 +545,12 @@
       !                                      
       DO jk = 1, jpk
-         fse3t(:,:,jk)= e3t_temp(:,:,jk) 
-         fse3u(:,:,jk)= e3u_temp(:,:,jk) 
-         fse3v(:,:,jk)= e3v_temp(:,:,jk) 
-         fse3w(:,:,jk)= e3w_temp(:,:,jk) 
+         fse3t(:,:,jk) = e3t_temp(:,:,jk) 
+         fse3u(:,:,jk) = e3u_temp(:,:,jk) 
+         fse3v(:,:,jk) = e3v_temp(:,:,jk) 
+         fse3w(:,:,jk) = e3w_temp(:,:,jk) 
       END DO
       !                                           !------------------------------!
       IF( lk_vvl ) THEN                           !  Update Now Vertical coord.  !   (only in vvl case)
-        !                                           !------------------------------!
+        !                                         !------------------------------!
          DO jk = 1, jpkm1
             fsdept(:,:,jk) = fsdept_n(:,:,jk)          ! now local depths stored in fsdep. arrays
@@ -803,14 +575,14 @@
          tsn_tm  (:,:,:,jp_sal) = tsn  (:,:,:,jp_sal) * fse3t(:,:,:)  
          rhop_tm (:,:,:)        = rhop (:,:,:)        * fse3t(:,:,:)  
-         avt_tm  (:,:,:)        = avt  (:,:,:)        * fse3w(:,:,:)  
+         avt_tm  (:,:,:)        = avt  (:,:,:) 
 # if defined key_zdfddm
-         avs_tm  (:,:,:)        = avs  (:,:,:)        * fse3w(:,:,:)  
-# endif
-#if defined key_ldfslp
-         wslpi_tm(:,:,:)        = wslpi(:,:,:)        * fse3w(:,:,:) 
-         wslpj_tm(:,:,:)        = wslpj(:,:,:)        * fse3w(:,:,:) 
-         uslp_tm (:,:,:)        = uslp (:,:,:)        * fse3u(:,:,:) 
-         vslp_tm (:,:,:)        = vslp (:,:,:)        * fse3v(:,:,:) 
-#endif
+         avs_tm  (:,:,:)        = avs  (:,:,:)
+# endif
+      IF( l_ldfslp ) THEN
+         wslpi_tm(:,:,:)        = wslpi(:,:,:)
+         wslpj_tm(:,:,:)        = wslpj(:,:,:)
+         uslp_tm (:,:,:)        = uslp (:,:,:)
+         vslp_tm (:,:,:)        = vslp (:,:,:)
+      ENDIF
       !
       sshb_hold  (:,:) = sshn  (:,:)
@@ -840,49 +612,12 @@
 # endif
       !
-#if defined key_traldf_c3d
       DO jk = 1, jpkm1
-         ahtt_tm(:,:,jk) = ahtt(:,:,jk) * fse3t(:,:,jk)
-         ahtu_tm(:,:,jk) = ahtu(:,:,jk) * fse3u(:,:,jk)
-         ahtv_tm(:,:,jk) = ahtv(:,:,jk) * fse3v(:,:,jk)
-         ahtw_tm(:,:,jk) = ahtw(:,:,jk) * fse3w(:,:,jk)
+         ahtu_tm(:,:,jk) = ahtu(:,:,jk)
+         ahtv_tm(:,:,jk) = ahtv(:,:,jk)
+         IF( ln_ldfeiv ) THEN
+            aeiu_tm(:,:,jk) = aeiu(:,:,jk) * fse3u(:,:,jk)
+            aeiv_tm(:,:,jk) = aeiv(:,:,jk) * fse3v(:,:,jk)
+         ENDIF
       END DO
-#elif defined key_traldf_c2d
-      ahtt_tm(:,:)   = ahtt(:,:)
-      ahtu_tm(:,:)   = ahtu(:,:)
-      ahtv_tm(:,:)   = ahtv(:,:)
-      ahtw_tm(:,:)   = ahtw(:,:)
-#elif defined key_traldf_c1d
-      ahtt_tm(:)     = ahtt(:)
-      ahtu_tm(:)     = ahtu(:)
-      ahtv_tm(:)     = ahtv(:)
-      ahtw_tm(:)     = ahtw(:)
-#else
-      ahtt_tm        = ahtt
-      ahtu_tm        = ahtu
-      ahtv_tm        = ahtv
-      ahtw_tm        = ahtw
-#endif
-      !
-#if defined key_traldf_eiv
-#  if defined key_traldf_c3d
-      DO jk = 1, jpk
-         aeiu_tm(:,:,jk) = aeiu(:,:,jk) * fse3u(:,:,jk)
-         aeiv_tm(:,:,jk) = aeiv(:,:,jk) * fse3v(:,:,jk)
-         aeiw_tm(:,:,jk) = aeiw(:,:,jk) * fse3w(:,:,jk)
-      END DO
-#  elif defined key_traldf_c2d
-      aeiu_tm(:,:)   = aeiu(:,:)
-      aeiv_tm(:,:)   = aeiv(:,:)
-      aeiw_tm(:,:)   = aeiw(:,:)
-#  elif defined key_traldf_c1d
-      aeiu_tm(:)     = aeiu(:)
-      aeiv_tm(:)     = aeiv(:)
-      aeiw_tm(:)     = aeiw(:)
-#  else
-      aeiu_tm        = aeiu
-      aeiv_tm        = aeiv
-      aeiw_tm        = aeiw
-#  endif
-#endif
       !
       IF( nn_timing == 1 )  CALL timing_stop('trc_sub_reset')
@@ -958,5 +693,6 @@
       ENDIF
       !
-      CALL div_cur( kt )                              ! Horizontal divergence & Relative vorticity
+!!gm BUG here  the recomputed divergence will includes the wrong river runoff.....
+      CALL div_hor( kt )                              ! Horizontal divergence 
       !
       z2dt = 2._wp * rdt                              ! set time step size (Euler/Leapfrog)
@@ -979,31 +715,22 @@
       CALL agrif_ssh( kt )
 #endif
-#if defined key_obc
-      IF( Agrif_Root() ) THEN 
-         ssha(:,:) = ssha(:,:) * obctmsk(:,:)
-         CALL lbc_lnk( ssha, 'T', 1. )                 ! absolutly compulsory !! (jmm)
-      ENDIF
-#endif
 #if defined key_bdy
       ssha(:,:) = ssha(:,:) * bdytmask(:,:)
       CALL lbc_lnk( ssha, 'T', 1. ) 
 #endif
-
+      !
       !                                                ! Sea Surface Height at u-,v- and f-points (vvl case only)
 !!Z~  IF( lk_vvl ) THEN                                ! (required only in key_vvl case)
 !!Z~     DO jj = 1, jpjm1
 !!Z~        DO ji = 1, jpim1      ! NO Vector Opt.
-!!Z~           sshu_a(ji,jj) = 0.5  * umask(ji,jj,1) / ( e1u(ji  ,jj) * e2u(ji  ,jj) )                   &
-!!Z~              &                                  * ( e1t(ji  ,jj) * e2t(ji  ,jj) * ssha(ji  ,jj)     &
-!!Z~              &                                    + e1t(ji+1,jj) * e2t(ji+1,jj) * ssha(ji+1,jj) )
-!!Z~           sshv_a(ji,jj) = 0.5  * vmask(ji,jj,1) / ( e1v(ji,jj  ) * e2v(ji,jj  ) )                   &
-!!Z~              &                                  * ( e1t(ji,jj  ) * e2t(ji,jj  ) * ssha(ji,jj  )     &
-!!Z~              &                                    + e1t(ji,jj+1) * e2t(ji,jj+1) * ssha(ji,jj+1) )
+!!Z~           sshu_a(ji,jj) = 0.5  * umask(ji,jj,1) * r1_e1e2u(ji  ,jj) * ( e1e2t(ji  ,jj) * ssha(ji  ,jj)   &
+!!Z~              &                                                        + e1e2t(ji+1,jj) * ssha(ji+1,jj) )
+!!Z~           sshv_a(ji,jj) = 0.5  * vmask(ji,jj,1) * r1_e1e2v(ji,jj  ) * ( e1e2t(ji,jj  ) * ssha(ji,jj  )     &
+!!Z~              &                                                        + e1e2t(ji,jj+1) * ssha(ji,jj+1) )
 !!Z~        END DO
 !!Z~     END DO
 !!Z~     CALL lbc_lnk( sshu_a, 'U', 1. )   ;   CALL lbc_lnk( sshv_a, 'V', 1. )      ! Boundaries conditions
 !!Z~  ENDIF
-      
-
+      !
       !                                           !------------------------------!
       !                                           !     Now Vertical Velocity    !
@@ -1019,5 +746,4 @@
 #endif
       END DO
-
       !
       CALL wrk_dealloc( jpi, jpj, zhdiv )
@@ -1045,11 +771,15 @@
          &      e3t_temp(jpi,jpj,jpk)       ,  e3u_temp(jpi,jpj,jpk),    &
          &      e3v_temp(jpi,jpj,jpk)       ,  e3w_temp(jpi,jpj,jpk),    &
-#if defined key_ldfslp
+!!gm here define these arrays only if l_ldfslp = True 
          &      wslpi_temp(jpi,jpj,jpk)     ,  wslpj_temp(jpi,jpj,jpk),  &
          &      uslp_temp(jpi,jpj,jpk)      ,  vslp_temp(jpi,jpj,jpk),   &
-#endif
+         &      wslpi_tm(jpi,jpj,jpk)       ,  wslpj_tm(jpi,jpj,jpk),    &
+         &      uslp_tm(jpi,jpj,jpk)        ,  vslp_tm(jpi,jpj,jpk),     &
+!!gm
 #if defined key_trabbl
          &      ahu_bbl_temp(jpi,jpj)       ,  ahv_bbl_temp(jpi,jpj),    &
          &      utr_bbl_temp(jpi,jpj)       ,  vtr_bbl_temp(jpi,jpj),    &
+         &      ahu_bbl_tm(jpi,jpj)         ,  ahv_bbl_tm(jpi,jpj),      &
+         &      utr_bbl_tm(jpi,jpj)         ,  vtr_bbl_tm(jpi,jpj),      &
 #endif
          &      rnf_temp(jpi,jpj)           ,  h_rnf_temp(jpi,jpj) ,     &
